﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Simplex_Method
{
    internal class Simplex
    {
        public decimal[,] Entering_data()
        {
            Console.WriteLine("Ввод данных:");
            Console.Write("Введите количество базисов: ");
            int count_basis = Convert.ToInt32(Console.ReadLine()) + 1;
            Console.Write("Введите количество основных переменных: ");
            int count_peremen = Convert.ToInt32(Console.ReadLine())+count_basis;
            decimal[,] simplex_arr = new decimal[count_basis, count_peremen];
            int count = count_peremen - count_basis;
            for (int i = 0; i < count_basis; i++)
            {
                if (i < count_basis - 1)
                {
                    for (int i1 = 0; i1 < count_peremen-count_basis; i1++)
                    {
                        Console.WriteLine("Введите х{0} для {1} уравнения ограничений",i1+1, i+1);
                        simplex_arr[i, i1] = Convert.ToDecimal(Console.ReadLine());
                    }
                }
                else
                {
                    for (int i1 = 0; i1 < count_peremen-count_basis; i1++)
                    {
                        Console.WriteLine("Введите коэффициенты в целевой функции для х{0}", i1+1);
                        simplex_arr[i, i1] = (-1) * Convert.ToDecimal(Console.ReadLine());
                    }
                }
                for (int j = count_peremen - count_basis; j < count_peremen; j++)
                {
                    if (j < count_peremen - 1)
                    {
                        for (int i1 = count_peremen - count_basis; i1 < count_peremen - 1; i1++)
                        {
                            simplex_arr[i, i1] = 0;
                            simplex_arr[i, count] = 1;
                        }
                        
                    }
                    else if (i == count_basis - 1) simplex_arr[i, j] = 0;
                    else
                    {
                        Console.WriteLine("Введите значения L(x) для {0} уравнения ограничений", i + 1);
                        simplex_arr[i, j] = Convert.ToDecimal(Console.ReadLine());
                    }
                }
                count++;
            }
            for (int i = 0; i < count_basis; i++)
            {
                for (int j = 0; j < count_peremen; j++)
                {
                    Console.Write("[" + i + "," + j + "]: " + Math.Round(simplex_arr[i, j], 5) + "\t");
                }
                Console.WriteLine();
            }
            Console.WriteLine();
            return simplex_arr;
        }
        public void Maximum_task(decimal[,] simplex_arr)
        {
            int count = 0;
            while (count<1)
            {
                decimal min = simplex_arr[0, 0];
                int min_j = 0;
                for (int i = simplex_arr.GetLength(0) - 1; i < simplex_arr.GetLength(0); i++) //Определение ведущего столбца
                {
                    for (int j = 0; j < simplex_arr.GetLength(1); j++)
                    {
                        if (min > simplex_arr[i, j])
                        {
                            min = simplex_arr[i, j];
                            min_j = j;
                        }

                    }
                }
                decimal min_sb = simplex_arr.Length;
                int min_i = 0;
                for (int i = 0; i < simplex_arr.GetLength(0) - 1; i++)
                {
                    for (int j = simplex_arr.GetLength(1) - 1; j < simplex_arr.GetLength(1); j++) //Определение ведущей строки
                    {
                        if (simplex_arr[i, j] > 0 && simplex_arr[i, min_j] > 0 && min_sb > simplex_arr[i, j] / simplex_arr[i, min_j])
                        {
                            min_sb = simplex_arr[i, j] / simplex_arr[i, min_j];
                            min_i = i;
                        }
                    }
                }
                decimal helper = simplex_arr[min_i, min_j];
                for (int i = min_i; i < min_i + 1; i++) //Получение единицы на пересечении ведущей строки и ведущего столбца
                {
                    for (int j = 0; j < simplex_arr.GetLength(1); j++)
                    {
                        if (helper != 1)
                        {
                            simplex_arr[i, j] = simplex_arr[i, j] / helper;
                        }
                    }
                }
                decimal[,] copy_arr = (decimal[,])simplex_arr.Clone();
                for (int i = 0; i < simplex_arr.GetLength(0); i++) //
                {
                    for (int j = 0; j < simplex_arr.GetLength(1); j++)
                    {
                        if (i == min_i)
                        {
                            continue;
                        }
                        else
                        {
                            copy_arr[i, j] = simplex_arr[i, j] + ((-1) * simplex_arr[i, min_j]) * simplex_arr[min_i, j];
                        }
                    }
                }
                for (int i = 0; i < copy_arr.GetLength(0); i++) //Вывод массива
                {
                    for (int j = 0; j < copy_arr.GetLength(1); j++)
                    {
                        simplex_arr[i, j] = copy_arr[i, j];
                        Console.Write("[" + i + "," + j + "]: " + Math.Round(copy_arr[i, j],5) + "\t");
                    }
                    Console.WriteLine();
                }
                Console.WriteLine();
                int count_arr = 0;
                for (int i = copy_arr.GetLength(0) - 1; i < copy_arr.GetLength(0); i++)
                {
                    for (int j = 0; j < copy_arr.GetLength(1); j++)
                    {
                        if (copy_arr[i, j] < 0)
                        {
                            continue;
                        }
                        else
                        {
                            count_arr++;
                            if (count_arr == copy_arr.GetLength(1)) count++;
                        }
                    }
                }
            }
            Console.WriteLine("Ответ: L(x) = {0}", Math.Round(simplex_arr[simplex_arr.GetLength(0) - 1, simplex_arr.GetLength(1) - 1],5));
            int id_new = 0;
            for (int i = simplex_arr.GetLength(0) - 1; i < simplex_arr.GetLength(0); i++) //ответ
            {
                for (int j = 0; j < simplex_arr.GetLength(1)-1; j++)
                {
                    if (simplex_arr[i, j] != 0)
                    {
                        Console.WriteLine("x{0} = {1}", id_new+1, Math.Round(simplex_arr[i,j], 5));
                        id_new++;
                    }
                }
            }
            
        }
        public void Minimum_task(decimal[,] simplex_arr)
        {
            int count = 0;
            while (count < 1)
            {
                decimal max = -2000000000;
                int max_j = 0;
                for (int i = simplex_arr.GetLength(0) - 1; i < simplex_arr.GetLength(0); i++) //Определение ведущего столбца
                {
                    for (int j = 0; j < simplex_arr.GetLength(1); j++)
                    {
                        if (max < simplex_arr[i, j])
                        {
                            max = simplex_arr[i, j];
                            max_j = j;
                        }

                    }
                }
                decimal max_sb = simplex_arr.Length;
                int max_i = 0;
                for (int i = 0; i < simplex_arr.GetLength(0) - 1; i++)
                {
                    for (int j = simplex_arr.GetLength(1) - 1; j < simplex_arr.GetLength(1); j++) //Определение ведущей строки
                    {
                        if (simplex_arr[i, j]>0 && simplex_arr[i, max_j] > 0 && max_sb > simplex_arr[i, j] / simplex_arr[i, max_j] )
                        {
                            max_sb = simplex_arr[i, j] / simplex_arr[i, max_j];
                            max_i = i;
                        }
                    }
                }
                decimal helper = simplex_arr[max_i, max_j];
                for (int i = max_i; i < max_i + 1; i++) //Получение единицы на пересечении ведущей строки и ведущего столбца
                {
                    for (int j = 0; j < simplex_arr.GetLength(1); j++)
                    {
                        if (helper != 1)
                        {
                            simplex_arr[i, j] = simplex_arr[i, j] / helper;
                        }
                    }
                }
                decimal[,] copy_arr = (decimal[,])simplex_arr.Clone();
                for (int i = 0; i < simplex_arr.GetLength(0); i++) //
                {
                    for (int j = 0; j < simplex_arr.GetLength(1); j++)
                    {
                        if (i == max_i)
                        {
                            continue;
                        }
                        else
                        {
                            copy_arr[i, j] = simplex_arr[i, j] + ((-1) * simplex_arr[i, max_j]) * simplex_arr[max_i, j];
                        }
                    }
                }
                for (int i = 0; i < copy_arr.GetLength(0); i++) //Вывод массива
                {
                    for (int j = 0; j < copy_arr.GetLength(1); j++)
                    {
                        simplex_arr[i, j] = copy_arr[i, j];
                        Console.Write("[" + i + "," + j + "]: " + Math.Round(copy_arr[i, j],5) + "\t");
                    }
                    Console.WriteLine();
                }
                Console.WriteLine();
                int count_arr = 0;
                for (int i = copy_arr.GetLength(0) - 1; i < copy_arr.GetLength(0); i++)
                {
                    for (int j = 0; j < copy_arr.GetLength(1); j++)
                    {
                        if (copy_arr[i, j] > 0)
                        {
                            continue;
                        }
                        else
                        {
                            count_arr++;
                            if (count_arr == copy_arr.GetLength(1)) count++;
                        }
                    }
                }
            }
            Console.WriteLine("Ответ: L(x) = {0}", Math.Round(simplex_arr[simplex_arr.GetLength(0) - 1, simplex_arr.GetLength(1) - 1], 5));
            int id_new = 0;
            for (int i = simplex_arr.GetLength(0) - 1; i < simplex_arr.GetLength(0); i++) //ответ
            {
                for (int j = 0; j < simplex_arr.GetLength(1) - 1; j++)
                {
                    if (simplex_arr[i, j] != 0)
                    {
                        Console.WriteLine("x{0} = {1}", id_new + 1, Math.Round(simplex_arr[i, j], 5));
                        id_new++;
                    }
                }
            }
        }
        public void task_selection()
        {
            while (true)
            {
                Console.WriteLine("Выберите тип задачи: " +
                    "\n1. На максимум" +
                    "\n2. На минимум" +
                    "\n0. Выход из программы");
                int choice = Convert.ToInt32(Console.ReadLine());
                if (choice == 1)
                {
                    Maximum_task(Entering_data());
                }
                else if (choice == 2)
                {
                    Minimum_task(Entering_data());
                }
                else if (choice == 0)
                {
                    break;
                }
                else
                {
                    Console.WriteLine("Такого типа задачи нет, выберите еще раз!");
                }
            }
        }
    }
}
